;NES Copper Bars demo
;Run program for description
;Quietust, 2004/07/04

.org $0000
ptr:		.block 2	;for initializing VRAM
vbflag:		.block 1	;signal when we've gotten an NMI
overflow:	.block 1	;

rbars:	.block $06	;this holds the position of each bar
ctabl:	.block $C0	;this stores the colour of each scanline

.org $C000

text:
.db "                                "
.db "      NES Copper Bars Demo      "
.db "________________________________"
.db "                                "
.db "  This 'copper bars' effect is  "
.db "  accomplished using a          "
.db "  combination of colour         "
.db "  emphasis, pattern table       "
.db "  swapping, grayscale mode,     "
.db "  and nametable switching.      "
.db "                                "
.db "  The far top and bottom lines  "
.db "  on each bar are done using    "
.db "  an alternate pattern table    "
.db "  with a mid-gray background.   "
.db "                                "
.db "  The middle lines are done by  "
.db "  shifting the dark gray to a   "
.db "  brighter gray by enabling     "
.db "  grayscale mode.               "
.db "                                "
.db "  The center lines are done by  "
.db "  switching to a nametable      "
.db "  filled with solid white.      "
.db "                                "
.db "  Looks pretty neat, huh?  :-)  "
.db "________________________________"
.db "                                "
.db "      Written by: Quietust      "
.db "                                "
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00

		;Raster bar table generator
		;written by Kevin Horton

do_rast:	LDX #$00	;updates the raster buffer
		TXA

clrast:		STA ctabl,x	;clear out all rasters
		INX
		CPX #$C2
		BNE clrast

		CLC		;only have to do this once here
		LDX #$05	;# of raster bars to do (minus 1)

dr_loop:	LDA rbars,x 
		INC rbars,x	;get & inc raster bar
		TAY
		LDA sinetab,y	;get position
		TAY
		LDA coltab,x	;get starting colour
		ORA #$80
		STA ctabl+0,y	;store the 1s
		STA ctabl+4,y
		ORA #$40
		STA ctabl+1,y	;then the 2s
		STA ctabl+3,y
		ORA #$20
		STA ctabl+2,y	;then 3, for "12321"
		DEX
		BPL dr_loop
		RTS

rast_init:	LDX #$05	;initalizes the raster bar positions
ri1:		TXA
		ASL A
		ASL A
		ASL A
		STA rbars,x
		DEX
		BPL ri1

		LDX #$00
		TXA

ri2:		STA ctabl,x	;clear out all raster bars
		INX
		BPL ri2
		RTS

coltab:
.db $14,$04,$0C,$08,$18,$10

sinetab:     
.db $5E,$60,$62,$64,$67,$69,$6B,$6E,$70,$72,$74,$77,$79,$7B,$7D,$7F
.db $81,$84,$86,$88,$8A,$8C,$8E,$90,$92,$94,$96,$97,$99,$9B,$9D,$9E
.db $A0,$A2,$A3,$A5,$A6,$A8,$A9,$AA,$AC,$AD,$AE,$AF,$B0,$B1,$B2,$B3
.db $B4,$B5,$B6,$B7,$B7,$B8,$B9,$B9,$BA,$BA,$BA,$BB,$BB,$BB,$BB,$BB
.db $BC,$BB,$BB,$BB,$BB,$BB,$BA,$BA,$BA,$B9,$B9,$B8,$B7,$B7,$B6,$B5
.db $B4,$B3,$B2,$B1,$B0,$AF,$AE,$AD,$AC,$AA,$A9,$A8,$A6,$A5,$A3,$A2
.db $A0,$9E,$9D,$9B,$99,$97,$95,$94,$92,$90,$8E,$8C,$8A,$88,$86,$84
.db $81,$7F,$7D,$7B,$79,$76,$74,$72,$70,$6D,$6B,$69,$67,$64,$62,$60
.db $5D,$5B,$59,$56,$54,$52,$50,$4D,$4B,$49,$47,$44,$42,$40,$3E,$3C
.db $39,$37,$35,$33,$31,$2F,$2D,$2B,$29,$27,$25,$24,$22,$20,$1E,$1D
.db $1B,$19,$18,$16,$15,$13,$12,$11,$0F,$0E,$0D,$0C,$0B,$09,$08,$08
.db $07,$06,$05,$04,$04,$03,$02,$02,$01,$01,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$01,$01,$01,$02,$02,$03,$04,$04,$05,$06
.db $07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F,$11,$12,$13,$15,$16,$18,$1A
.db $1B,$1D,$1E,$20,$22,$24,$26,$28,$29,$2B,$2D,$2F,$31,$33,$35,$38
.db $3A,$3C,$3E,$40,$42,$45,$47,$49,$4B,$4E,$50,$52,$54,$57,$59,$5B

nmi:		PHA
		TXA
		PHA
		TYA
		PHA
		LDA #$00
		STA $2003
		LDA #$02
		STA $4014
		LDA #$01
		STA vbflag
		LDA #$98
		STA $2000
		LDA #$1E
		STA $2001
		LDA #$00
		STA $2005
		STA $2005
		JSR do_rast
		PLA
		TAY
		PLA
		TAX
		PLA
irq:		RTI

reset:		SEI
		CLD
		LDA #$00
		STA $2000
		STA $2001
		LDX #$02
waitframe:	LDA $2002
		BPL waitframe
		DEX
		BPL waitframe
		TXS

		LDA #$00
		TAX
clr_ram:	STA $00,X
		STA $0200,X
		STA $0300,X
		STA $0400,X
		STA $0500,X
		STA $0600,X
		STA $0700,X
		INX
		BNE clr_ram

		LDX #$20
		STX $2006
		LDY #$00
		STY $2006

		LDA #text & $FF
		STA ptr
		LDA #text >> 8
		STA ptr+1

		LDX #$04
init_vram1:	LDA (ptr),Y	;load text for primary NT
		STA $2007
		INY
		BNE init_vram1
		INC ptr+1
		DEX
		BNE init_vram1

		LDX #$04
		LDA #$FF
init_vram2:	STA $2007	;load white for secondary NT
		INY
		BNE init_vram2
		DEX
		BNE init_vram2

		LDX #$00
		LDA #$FF 
spr_init:	STA $0200,X	;move all sprites offscreen
		INX
		INX
		INX
		INX
		BNE spr_init

		LDA #$0F	;except sprite 0, which we'll be using for hit
		STA $0200
		LDA #'_'
		STA $0201

		LDX #$3F
		LDY #$00
		STX $2006
		STY $2006

		LDX #$08
palloop:	LDA #$1D
		STA $2007
		STA $2007
		LDY #$2D
		STY $2007
		LDY #$30
		STY $2007
		DEX
		BNE palloop

		LDA #$3F
		STA $2006
		LDA #$00
		STA $2006
		STA $2006
		STA $2006

		STA $2005
		STA $2005		;clear scroll regs
		STA $4015		;kill sound
		STA vbflag
                LDA #$C0
                STA $4017               ;disable frame IRQs
		JSR rast_init
		LDA #$98
		STA $2000
		CLI

loop:		LDA vbflag
		BEQ loop
		LDA #$00
		STA vbflag

spr0off:	BIT $2002
		BVS spr0off
spr0on:		BIT $2002
		BVC spr0on
		LDX #$FF
		STX overflow
		INX
		LDY #$13
sync:		DEY
		BNE sync
scanloop:	LDA ctabl,x		;4
					;cut 6 cycles
		ASL A			;12
		BCC color0		;14
		ASL A			;16
		BCC color1		;18
		ASL A			;20
		BCC color2		;22
		NOP			;24
		NOP			;26
		NOP			;28
		ORA #$01		;30
		NOP			;32
		NOP			;34
		LDY #$0A		;36
c3w:		DEY			;56
		BNE c3w			;85
		LDY #$99		;insert them
		STY $2000		;here
		JMP endloop		;88

color2:					;23
		ORA #$01		;25
		NOP			;27
		NOP			;29
		LDY #$0B		;31
c2w:		DEY			;53
		BNE c2w			;85
		LDY #$98		;and
		STY $2000		;here
		JMP endloop		;88

color1:					;19
		ASL A			;21
		NOP			;23
		NOP			;25
		NOP			;27
		NOP			;29
		LDY #$0B		;31
c1w:		DEY			;53
		BNE c1w			;85
		LDY #$80		;and
		STY $2000		;here
		JMP endloop		;88

color0:					;15
		LDA #$00		;17
		LDY #$0E		;19
c0w:		DEY			;47
		BNE c0w			;88
		LDY #$98		;and
		STY $2000		;here

endloop:			;88
		ORA #$1E	;90
		STA $2001	;94

		CLC		;96
		LDA overflow	;99
		ADC #$55	;101
		STA overflow	;104
		BCC skip	;106+2/3
skip:		

		INX		;108+2/3
		CPX #$BF	;110+2/3
		BNE scanloop	;113+2/3

		LDA #$98
		STA $2000
		LDA #$1E
		STA $2001
		JMP loop

.fill $FFFA-*,$00
.org $FFFA
.dw nmi
.dw reset
.dw irq
.end
